{% extends "layout.html" %}
{% block content %}
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>WSI Annotator</title>
    <link rel="stylesheet" type="text/css" href="/static/mytemplate_with_comments.css" />
{#    <script type="text/javascript" src="{{ url_for('static', filename='jquery.js') }}"></script>#}
{#    for POST and GET#}
    <script type="text/javascript" src="{{ url_for('static', filename='jquery.min.js') }}"></script>
    <script type="text/javascript" src="{{ url_for('static', filename='openseadragon.js') }}"></script>
{#    <script type="text/javascript" src="{{ url_for('static', filename='openseadragon-scalebar.js') }}"></script> #}

    <style>
        body {
            font-family: "Helvetica", Arial;
            width: 100%;
            height: 100vh;
            margin: 0;
            float: left;
            background-color: rgb(250, 250, 250);
        }
        .heading {
            float: left;
            width: 100%;
            height: 50px;
            box-shadow: 0 2px 2px #888888;
            margin-bottom: 12px;
        }
        .heading h1 {
            float: left;
            color: #0f0f0f;
            width: 50%;
            margin: 5px auto 5px 15px;
            padding: 5px 0 5px 15px;
            {#background-color: #bef1b8;#}
            {#border-radius: 10px 10px 0 0;#}
        }
        .heading form {
            float: right;
        }
        #logout{
            float:right;
            margin: 10px 20px 10px 0;
            border-radius: 25px;
            background-color: #269ccc;
            height: 30px;
            width: 100px;
            color: white;
            font-weight: bold;
        }

        #logout:hover{
            float:right;
            border-radius: 25px;
            background-color: #269ccc;
            height: 50px;
            width: 100px;
            cursor: pointer;
        }
        h3 {
            margin: 10px 0 5px 0;
        }

        div.area_container {
            margin-left: 1%;
            margin-right: 1%;
        }

        div#operation.area_container {
            float: left;
            height: calc(100% - 62px);
            width: 98%;
        }

        div#config.area_container {
            float: left;
            margin-top: 10px;
            margin-bottom: 10px;
            width: 98%;
            height: calc(30% - 20px);
            overflow-y: scroll;

            display: none;
        }

        /* OSD */
        div#openseadragon1 {
            float: left;
            margin: 0;
            width: 70%;
            height: calc(100% - 40px);
        }

        div#side_panel {
            float: left;
            width: 28%;
            height: calc(100% - 40px);
            padding: 0 1% 0 1%;

            overflow: auto;

            display: flex;
            flex-direction: column;
        }

        div#main_control {
            float: left;
            width: 100%;
            margin-bottom: 10px;

            flex: initial;

            border-bottom: 2px solid #3f3e3e;
        }

        button#hl_btn {
            float: left;
            height: 100%;
            margin-right: 10px;
        }

        div#tb_list {
            float: left;
            clear: left;
        }

        div#tb_warn {
            float: left;
            clear: left;
            color: red;
        }

        ul#tba_ul_list {
            margin: 3px 0 3px 0;
        }

        li.clicky {
            cursor: pointer;
        }

        li.clicky:hover {
            color: red;
            background-color: yellow;
        }

        li#reg_selected {
            padding: 3px;
            background-color: #234669;
            color: white;
        }

        div#meta_data_container {
            float: left;
            width: 98%;
            height: auto;
            overflow-y: auto;

            flex: auto;
        }

        div#scale_bar {
            position:absolute;
            top: 90%;
            left: 3%;

            width: 100px;
            background-color: rgba(125,125,125,0.2);
            text-align: center;
            border: 1px solid #000;
        }

        div#status_bar_container {
            clear: both;
            float: left;
            height: 30px;
            padding-top: 10px;
            padding-left: 2%;
            width: 68%;
        }

        div#vmag_container {
            float: left;
            height: 100%;
            width: 40%;
        }

        div#status_container {
            float: left;
            width: 25%;
        }

        div#error_container{
            float: right;
            width: 20%;
        }

        div#upper_control_container {
            float: left;
            width: 100%;
            margin-top: 10px;
        }



        div#setup_control {
            float: left;
            width: 46%;
            margin-left: calc(2% - 2px);
            padding-left: 2%;
            border-left: 1px solid #3f3e3e;
        }

        div#lower_control_container {
            float: left;
            width: 100%;
            margin-top: 10px;
            padding-top: 5px;
            border-top: 1px solid #3f3e3e;
        }

        h2.control_header, span.control_header {
            background-color: #269ccc;
            color: white;
            padding: 6px;
            margin: 5px 0 0 0;
            font-weight: bold;
            font-size: 18px;
        }

        div.control_content {
            background-color: #9ed2c5;
            padding: 6px;
        }
    </style>

</head>

<body>
<div class="heading">
    <h1>
        OpenHI <span style="font-size: 50%; color: #3f3e3e;">v1</span>
    </h1>

    <form name="logout" action="/logout/" method="post">
        <input id="logout" type="submit" value="Logout">
    </form>
</div>

<div class="area_container" id="operation">

    <div id="openseadragon1"></div>
    <div id="side_panel">
        <div id="main_control">
            <h2 class="control_header">Pre-segmentation level</h2>
                <div class="control_content" id="PS_lv"></div>

            <h2 class="control_header">Tumor grading</h2>
                <div class="control_content" id="grading"></div>

            <div style="padding: 10px 0 10px 0;">
                <span class="control_header" style="height: 100%; margin-right: 10px">Click to undo: </span>

                <a href=# id=undo><button class='btn btn-default'>Undo</button></a>
            </div>

            <div style="padding: 10px 0 0 0;">
                <span class="control_header" style="height: 100%; margin-right: 10px">Show/hide: </span>
                <a href=# id=tog_boun><button class='btn btn-default'>Boundary</button></a>
                <p id="tog_result" style="margin-top: 5px; margin-bottom: 5px">Toggle switch: ...</p>
            </div>

            <!-- Slide control -->
            <div class="container" style="margin: 0 0 10px 0; width: calc(100% - 10px); float: left;">
                <span class="control_header" style="height: 100%; margin:0 10px 0 0; float: left;">Slide ID: </span>

                <form>
                    <input id="slide_id_input_box" style="float: left; margin-right: 4px" type=text size=5 name=slide_id>
                    <p id="change_result_flash" style="color:red"></p>
                    <a href=# id=slide_id style="float:left;"><button class='btn btn-default'>Change Slide</button></a>
                </form>

                <span id=slide_result>Current slide: unknown</span>
            </div>

            <!-- High-low magnification control  -->
            <div class="container" style="margin: 0 0 10px 0; width: calc(100% - 10px); float: left; clear: both;">
                <span class="control_header" style="float: left; height: 100%; margin:0 10px 0 0; font-size: 80%;">
                    Magnification Control:
                </span>
                <a href=# id="mag_l"><button class='btn btn-default' id="hl_btn">Low</button></a>
                <a href=# id="mag_h"><button class='btn btn-default' id="hl_btn">High</button></a>
            </div>

            <!-- TBA list -->
            <div class="container" style="margin: 0 0 10px 0; width: calc(100% - 10px); float: left; clear: both;">
                <span class="control_header" style="float: left; height: 100%; margin:0 10px 0 0; font-size: 80%;">
                    To be annotated list:
                </span>
                <a href=# id="add_sw"><button class='btn btn-default' id="hl_btn">Add current region</button></a>
                <a href=# id="rm_sw"><button class='btn btn-default' id="hl_btn">Remove latest region</button></a>
                <div id="tb_list"></div>
                <div id="tb_warn"></div>
            </div>
        </div>

        <div id="meta_data_container">
                <div>
                <div id="meta_data" ><b>Slide Information</b></div>
                    <div id="clinical_meta_data" style="font-size: 21px"><b>Clinical Information</b></div>
                <div id="patient_info" >
                    <button id="demographic" style="font-size: 18px"><b>demographic</b></button>
                    <p id="demographic_info" style="display:none;margin-left:30px;margin-top: 3px;margin-bottom: 0px"></p>
                    <br>
                    <button id="diagnosis" style="font-size: 18px"><b>diagnosis</b></button>
                    <p id="diagnosis_info" style="display:none;margin-left:30px;margin-top: 3px;margin-bottom: 0px"></p>
                    <br>
                    <button id="exposure" style="font-size: 18px"><b>exposure</b></button>
                    <p id="exposure_info" style="display:none;margin-left:30px;margin-top: 3px;margin-bottom: 0px"></p>
                    <br>
                    <button id="family_history" style="font-size: 18px"><b>family_history</b></button>
                    <p id="family_history_info" style="display:none;margin-left:30px;margin-top: 3px;margin-bottom: 0px">No information</p>
                    <br>
                    <button id="follow_up" style="font-size: 18px"><b>follow_up</b></button>
                    <p id="follow_up_info" style="display:none;margin-left:30px;margin-top: 3px;margin-bottom: 0px">No information</p>
                    <br>
                    <button id="molecular_test" style="font-size: 18px"><b>molecular_test</b></button>
                    <p id="molecular_test_info" style="display:none;margin-left:30px;margin-top: 3px;margin-bottom: 0px">No information</p>
                    <br>
                    <button id="treatment" style="font-size: 18px"><b>treatment</b></button>
                    <p id="treatment_info" style="display:none;margin-left:30px;margin-top: 3px;margin-bottom: 0px">No information</p>
                </div>

                    <div id="bio_meta_data" style="font-size: 21px"><b>Biospecimen Information</b></div>
                <div id="bio_info">
                    <button id="slide" style="font-size: 18px;display:none"><b>slide</b></button>
                    <p id="slide_info" style="display:none;margin-left:30px;margin-top: 3px;margin-bottom: 0px"></p>
                    <br>
                    <button id="sample" style="font-size: 18px"><b>sample</b></button>
                    <p id="sample_info" style="display:none;margin-left:30px;margin-top: 3px;margin-bottom: 0px"></p>
                    <br>
                    <button id="portion" style="font-size: 18px;display:none"><b>portion</b></button>
                    <p id="portion_info" style="display:none;margin-left:30px;margin-top: 3px;margin-bottom: 0px"></p>
                    <br>
                </div>
                </div>
            </div>

    </div>

    <!-- This is the scale bar -->
    <div id="scale_bar">
        ...
    </div>

    <!-- Status bar container -->
    <div id="status_bar_container">
        <div id="vmag_container">
            <div style="float: left;">Virtual Magnification: x<span id="mag_show"></span></div>
            <br />
            <div style="display: none;">
                <div style="float: left; margin-right: 5px;">Adjust virtual magnification: x</div>
                <div>
                    <input type=text size=5 id="input-vmag" value="100">
                    <a href=# id="virtual-mag-usr-input"><button class='btn btn-default'>Update vMag</button></a>
                    <span style="font-style: italic"> - Do not change</span>
                </div>
            </div>
        </div>

        <div class="status_bar" id="status_container">
            <div style="float: left;">Status: <span id="status_show"></span></div>
        </div>

        <div id="error_container">
            <div style="float: left;background-color:#FF0000"> <span id="error_show"></span></div>
        </div>
    </div>
</div>

<div class="area_container" id="config">

    <div id="upper_control_container">


        <div id="setup_control">

            <div class="container">
                <h3>Screen Resolution: </h3>
                <form>
                    <select id="sr", onchange="onScreenResSelect()">

                    </select>
                    <div id="sr_o">
                        width:
                        <input type=text size=5 id=sr_ox value="1920">
                        height:
                        <input type=text size=5 id=sr_oy value="1080">
                    </div>
                    <a href=# id=sr_update><button class='btn btn-default'>Update Resolution</button></a>
                </form>
            </div>

            <div class="container">
                <h3>Screen Size (inch): </h3>
                <form>
                    <select id="ss", onchange="onScreenSizeSelect()">

                    </select>
                    <div id="ss_o">
                        size:
                        <input type=text size=5 id=ss_os value="24.0">
                    </div>
                    <a href=# id=ss_update><button class='btn btn-default'>Update Size</button></a>
                </form>
            </div>

            {% if ignore_hps %}
            <div class="container" style="display: none">
            {% else %}
            <div class="container">
            {% endif %}
                <h3>Distance from Screen (cm): </h3>
                <form>
                    <select id="ds", onchange="onDistanceSelect()">

                    </select>
                    <div id="ds_o">
                        distance:
                        <input type=text size=6 id=ds_od value="50">
                    </div>
                    <a href=# id=ds_update><button class='btn btn-default'>Update Distance</button></a>
                </form>
            </div>
        </div>
    </div>
    </div>

    <div id="lower_control_container">
        <div class="container">
            <h3 style="margin-bottom: 5px">Viewing coordinates adjustment (for debugging): </h3>
            <form>
                <h4 style="margin-top: 5px; margin-bottom: 5px">Top-left (location): </h4>
                <span style="margin-left: 15px;">x:</span>
                <input type=text size=5 name=tl_x1 value="1200">

                 y:
                <input type=text size=5 name=tl_y1 value="1500">

                <h4 style="margin-top: 5px; margin-bottom: 5px">Viewing size: </h4>

                <span style="margin-left: 15px;">image width:</span>
                <input type=text size=5 name=tl_x2 value="1300">

                <a href=# id=update_img_man><button class='btn btn-default'>Update Image</button></a>
                <br />
                <span style="font-style: italic; font-size: 80%">The height of the image is automatically calculated based on the width
                and the specified viewer size. </span>
            </form>
        </div>
    </div>
</div>


<script type="text/javascript">

    // Fixed values (For high and low magnification function)
    var low_mag_dim = 700;      // micron
    var high_mag_dim = 250;     // micron
    var micron_per_pixel = 0.25; // micron/pixel (from WSI metadata, valid only in TCGA-KIRC WSIs.)
    var reg_id = 0;             // 0 is default value, no sub-regions will have this value.

    // ----- To be annotated list related functions ----- //
    var reg_list = [];

    function makeUL(array) {
        // Create the list element:
        var list = document.createElement('ul');
        list.setAttribute("id", "tba_ul_list");

        for(var i = 0; i < array.length; i++) {
            // Create the list item:
            var item = document.createElement('li');
            item.setAttribute("class", "clicky");
            item.setAttribute("id", "regid_" + array[i].substring(7, array[i].length));
            item.setAttribute("onClick", "change_region(this.id)");

            // Set its contents:
            item.appendChild(document.createTextNode(array[i]));

            // Add it to the list:
            list.appendChild(item);
        }
        // Finally, return the constructed list:
        return list;
    }

    // Fetch TBA list information and update on the webpage.
    var update_tb_list = function() {
        // Update the TBA list
        // Fetch TBA list information and update on the webpage.
        $.getJSON('/_update_tb_list', {}, function(data) {
            var max_region = parseInt(data.max_region);
            reg_list = [];      // Clear the list.
            for(var i = 0; i < max_region; i++) {
                reg_list.push('Region ' + String(data.reg_list[i][0]));
            }
            document.getElementById('tb_list').innerHTML = "";
            document.getElementById('tb_list').appendChild(makeUL(reg_list));
        });
    };

    update_tb_list();

    function change_region(region_str) {
        if (reg_id != 0) {
            document.getElementById("reg_selected").id = "regid_" + String(reg_id);
        }
        reg_id = parseInt(region_str.substring(6, region_str.length));
        // Highlight the region id in the list
        document.getElementById("regid_" + String(reg_id)).id = "reg_selected";

        // Fetch the coordinate based on region id and update to the location
        $.getJSON('/_report_center', {reg_id: reg_id}, function(data) {
                    console.log("Update image to LOW magnification view...");
                    var bounds = viewer.viewport.getBounds();

                    // Calculate for the center of the image
                    var center_x = data.x;
                    var center_y = data.y;

                    var wh_ratio = bounds.height / bounds.width;

                    // Calculate the viewing width needed to be displayed
                    var px_disp_width = low_mag_dim / micron_per_pixel;
                    var px_disp_height = px_disp_width * wh_ratio;

                    UpLeft_X = center_x - (px_disp_width/2);
                    UpLeft_Y = center_y - (px_disp_height/2);

                    DownRight_X = UpLeft_X + px_disp_width;
                    DownRight_Y = UpLeft_Y + px_disp_height;

                    update_image();     // Run normal update_image routine.
                    return false;
        });
    }

    // ----- [END] To be annotated list related functions ----- //
    // Disable right-click
    window.oncontextmenu=function(e){
        e.preventDefault();
    };

    var data_draw = {}; //recording the points -> should be JSON
    var point_number=0; //the length of data_draw
    var OSD_status = 0; // 0= ready; 1 = posting; 2 = updating; 3 = waiting to update
    var OSD_ready = 0, OSD_posting = 1, OSD_updating = 2, OSD_waiting = 3;
    var sta_message=["Ready","Data Processing","Updating Image","Processing"];
    var error_message = ["","Something Wrong during data recording","Something wrong during processing image","please WAIT for READY"];

    var MAX_X = 5000, MAX_Y = 5000; // Default max value
	var UpLeft_X = 0, UpLeft_Y = 0; //coordinate of UpLeft (top-left coor)
    var X = 5000, Y = 5000; // width and height that the image asked for(change automatically)
    var DownRight_X = UpLeft_X + X, DownRight_Y = UpLeft_Y + Y; //coordinate of DownRight (bottom-right coor)
    var Max_zoom = 0;
    var PT_location = (0,0);

	var OCD_X_PX=1000,OCD_Y_PX=1000; //wide and length asking for (viewing image size)
    var ps_lv = 0, MAX_ps_lv = 2; // Max is 6
    var grading=0, Max_grading=4;   // Currently utilizing WHO/ISUP grading standard.
    var um_per_px=0.25;
    var max_image_zoom =5;
    var update_scale_bar_status=0;

    var keyboard=['Z','X','C','V','B','N','M']; //control the ps_lv

    var buffer = 0.05;

    var enableOverlay = false;

    var screen_res = [[160, 120], [240, 160], [320, 240], [400, 240], [480, 320], [640, 360], [640, 480], [768, 480], [800, 600], [854, 480], [960, 540], [960, 640], [1024, 576], [1024, 600], [1024, 768], [1152, 864], [1280, 720], [1280, 1024], [1366, 768], [1400, 1050], [1440, 900], [1600, 1200], [1680, 1050], [1920, 1080], [1920, 1200], [2048, 1152], [2048, 1536], [2560, 1440], [2560, 1600], [2560, 2048], [3200, 1800], [3200, 2048], [3200, 2400], [3440, 1440], [3840, 2160], [3840, 2400], [4096, 3072], [5120, 2880], [5120, 3200], [5120, 4096], [6400, 4096], [6400, 4800], [7680, 4320], [7680, 4800]];
    var screen_res_sel = document.getElementById('sr');
    var sr_oform = document.getElementById("sr_o");
    for (var i = 0; i < screen_res.length; i++) {
        var name = screen_res[i][0] + " x " + screen_res[i][1];
        screen_res_sel.options.add(new Option(name, ""));
    }
    screen_res_sel.options.add(new Option("other", ""));
    screen_res_sel.options[23].selected = true;
    sr_oform.style.display = "none";
    var onScreenResSelect = function() {
        sr_oform.style.display = (screen_res_sel.selectedIndex == screen_res.length ? "inline" : "none");
    };

    var screen_size = [1.33, 1.53, 2.8, 3.2, 3.3, 3.5, 3.7, 4.0, 4.2, 4.3, 4.5, 4.7, 4.8, 5.0, 5.3, 6.0, 7.0, 7.8, 8.9, 9.7, 10.0, 10.2, 11.1, 12.1, 13.3, 14.1, 15.0, 15.4, 15.6, 16.0, 17.0, 18.4, 19.0, 20.0, 21.5, 22.0, 22.1, 23.0, 24.0, 25.0, 26.0, 27.0, 28.0, 29.0, 30.0, 32.0];
    var screen_size_sel = document.getElementById('ss');
    var ss_oform = document.getElementById("ss_o");
    for (var i = 0; i < screen_size.length; i++) {
        screen_size_sel.options.add(new Option(screen_size[i], ""));
    }
    screen_size_sel.options.add(new Option("other", ""));
    screen_size_sel.options[29].selected = true;
    ss_oform.style.display = "none";
    var onScreenSizeSelect = function() {
        ss_oform.style.display = (screen_size_sel.selectedIndex == screen_size.length ? "inline" : "none");
    };

    var distance_from_screen = [10, 20, 30, 40, 50, 60, 70, 80, 90, 100];
    var distance_sel = document.getElementById('ds');
    var ds_oform = document.getElementById('ds_o');
    for (var i = 0; i < distance_from_screen.length; i++) {
        distance_sel.options.add(new Option(distance_from_screen[i], ""));
    }
    distance_sel.options.add(new Option("other", ""));
    distance_sel.options[4].selected = true;
    ds_oform.style.display = "none";
    var onDistanceSelect = function() {
        ds_oform.style.display = (distance_sel.selectedIndex == distance_from_screen.length ? "inline" : "none");
    };

    var mag_show = document.getElementById('mag_show');
    var img_div = document.getElementById('openseadragon1');
    var update_mag = function(callback = function(){}) {
        var srx, sry;
        if (screen_res_sel.selectedIndex == screen_res.length) {
            srx = parseInt(document.getElementById("sr_ox").value, 10);
            sry = parseInt(document.getElementById("sr_oy").value, 10);
        } else {
            srx = screen_res[screen_res_sel.selectedIndex][0];
            sry = screen_res[screen_res_sel.selectedIndex][1];
        }
        var sss;
        if (screen_size_sel.selectedIndex == screen_size.length) {
            sss = parseFloat(document.getElementById("ss_os").value);
        } else {
            sss = screen_size[screen_size_sel.selectedIndex];
        }
        var dsd;
        if (distance_sel.selectedIndex == distance_from_screen.length) {
            dsd = parseFloat(document.getElementById("ds_od").value);
        } else {
            dsd = distance_from_screen[distance_sel.selectedIndex];
        }

        var retJson = {
            swidth : srx, sheight : sry,
            ssize : sss, sdis: dsd,
            tlx : UpLeft_X, tly : UpLeft_Y,
            brx : DownRight_X, bry : DownRight_Y,
            iwidth : img_div.offsetWidth, iheight : img_div.offsetHeight
        };

        $.getJSON(
            '/_calc_mag',
            retJson,
            function(data) {
                console.log(data.status);
                $("#mag_show").text(data.mag);
                callback(data);
            });
    };
    update_mag();

    // variable related to the manual image adjustment.
    var manLoc_x1 = 0, manLoc_y1 = 0;
    var manLoc_w = 300;

    // Function to update wsi-s information so that zooming can work properly.
    var _update_image_info = function () {
        $.getJSON('/_get_info', {}, function(data) {  //get inform and create radio button,
            // Print received data from the back-end
            console.log(data);

            UpLeft_X = 0;
            UpLeft_Y = 0; //coordinate of UpLeft (top-left coor)

            MAX_X = data.img_width - 1;
            MAX_Y = data.img_height - 1;

            // X and Y is width and height of the image
            X = MAX_X;
            Y = MAX_Y;

            // Viewing full image
            DownRight_X = UpLeft_X + X;
            DownRight_Y = UpLeft_Y + Y;
            MAX_ps_lv = data.ps_lv;

            um_per_px = data.um_per_px;
            max_image_zoom = data.max_image_zoom;

        });
    };

    // Update image information
	$.getJSON('/_get_info', {}, function(data) {  //get inform and create radio button,
		console.log(data);
		MAX_X = data.img_width - 1;
        MAX_Y = data.img_height - 1;
		X=MAX_X;
		Y=MAX_Y;
		DownRight_X = UpLeft_X+X;
		DownRight_Y = UpLeft_Y+Y;
        MAX_ps_lv = data.ps_lv;

        {#Max_grading = data.grading#} // For future

        for(var i= 0 ; i<=MAX_ps_lv; i++)
        {
            var radio = document.createElement("input"); //syntax
            radio.type="radio";
            radio.name= "PS_lv";
            radio.id = "" + keyboard[i];
            radio.value=i;
            radio.onchange = function(){
                ps_lv=getRadioValue("PS_lv");}; // function is below
            var text = document.createTextNode(' '+keyboard[i]+' : ' + i +'\u00A0\u00A0');
            document.getElementById("PS_lv").appendChild(radio);
            document.getElementById("PS_lv").appendChild(text);
            document.getElementById(keyboard[i]).style.marginLeft = "5px";
        }

        for(var i= 0 ; i<=Max_grading; i++)
        {
            var radio = document.createElement("input");
            radio.type="radio";
            radio.name= "grading";
            radio.id = "" + i;
            radio.value=i;
            radio.onchange = function(){
                grading=getRadioValue("grading");};
            if(i==0){
                var text = document.createTextNode(' '+'Unmark [0]'+'\u00A0\u00A0');
            }
            else {
                var text = document.createTextNode(' '+i+'\u00A0\u00A0');
            }

            document.getElementById("grading").appendChild(radio);
            document.getElementById("grading").appendChild(text);
            document.getElementById(i.toString()).style.marginLeft = "10px";
        }

        {#document.getElementsByName("PS_lv").style.marginRight = "10px";#}
        document.getElementById("Z").checked=true;
        document.getElementById("0").checked=true;
	});

    var viewer = OpenSeadragon({
        id: "openseadragon1",
        prefixUrl: "{{ url_for('static', filename='images/') }}",
        tileSources: {
            type: 'image',
            url: "{{ slide_url}}",
        },
        minZoomImageRatio: 0,
        maxZoomPixelRatio: 30,
        autoResize: false,
        visibilityRatio: 0,
        

        gestureSettingsMouse: {
            flickEnabled: false,
        },

        springStiffness:5,// 5
        animationTime: 0.5, //0.5

        zoomPerSecond: 0.5,//0.5
        zoomPerScroll: 1.3,
        {#blendTime: 1,#}

	});

    //Changing OSD_status
    var set_status = function(sta){
        switch (sta){
            case 0:
                viewer.setMouseNavEnabled(true);
                OSD_status = sta;
                break;
            default:
                viewer.setMouseNavEnabled(false);
                OSD_status = sta;
        }
        $("#status_show").text(sta_message[sta]);
        //console.log('status='+OSD_status);
    };

    var show_error = function(error_number) {
        console.log(error_message[error_number]);
        $("#error_show").text(error_message[error_number]);
        if(error_number!=0)
            setTimeout("show_error(0)",2500);
    };

    // For both ps_lv and grading ratio buttons.
    var getRadioValue = function(name){ //get which item is chosen (name is radio name such as "PS_lv" and "grading")
        var radio_tag = document.getElementsByName(name);
        for(var i=0;i<radio_tag.length;i++){
            if(radio_tag[i].checked){
                return radio_tag[i].value;
            }
        }
    };

    var recording_point = function(event) {
                    var Point_position = viewer.viewport.pointFromPixel(event.position);
                    var data_get = {
                        x : UpLeft_X + Point_position.x * X,
                        y : UpLeft_Y + Point_position.y * X,
                        grading : grading,
                        ps_lv : ps_lv,
                    };
                    data_draw[''+point_number]=data_get;
                    point_number=point_number+1;
                };

    var Update_pointer_location= function (event) {
        var Point_position = viewer.viewport.pointFromPixel(event.position);
        var bounds = viewer.viewport.getBounds();
        PT_location = Point_position//(Point_position.x,Point_position.y);

    };

    var update_image = function(pt_false) {
        // Clear add sub-window warning
        document.getElementById("tb_warn").innerHTML = "";

        if (OSD_status != OSD_ready && OSD_status !=OSD_waiting ) {show_error(3);return;}
        set_status(OSD_updating);
        if (typeof pt_false == 'undefined')
            pt_false = '()';
		var data_askFor= { //asking image is larger than we see
			var1:Math.round (UpLeft_X-(DownRight_X-UpLeft_X)*buffer),    // buffer is the extra edge of the image that we load
            var2:Math.round (UpLeft_Y-(DownRight_Y-UpLeft_Y)*buffer),
            var3:Math.round (DownRight_X+(DownRight_X-UpLeft_X)*buffer),
			var4:Math.round (DownRight_Y+(DownRight_Y-UpLeft_Y)*buffer),
            var5:OCD_X_PX , var6:OCD_X_PX,   // 5 is static, var6 is change according to the image ratio.
            var7:ps_lv,
            var8:pt_false    // Note: This is temporary
		};

        //viewer.close();     // freeze the OSD
        if(data_askFor.var1<0){     data_askFor.var1=0;      }
        if(data_askFor.var2<0){     data_askFor.var2=0;      }
        if(data_askFor.var3>MAX_X){ data_askFor.var3=MAX_X;  }
        if(data_askFor.var4>MAX_Y){ data_askFor.var4=MAX_Y;  }
        data_askFor.var5=Math.round (1.5*document.getElementById("openseadragon1").clientWidth);
        data_askFor.var6=data_askFor.var5
                          *(data_askFor.var4-data_askFor.var2)
                          /(data_askFor.var3-data_askFor.var1);
        data_askFor.var6=Math.round (data_askFor.var6);
       
        console.log(data_askFor);
        Max_zoom = max_image_zoom * (data_askFor.var3-data_askFor.var1) / data_askFor.var5;
        //Max_zoom = viewer.viewport.imageToViewportZoom(Max_zoom);
        console.log(Max_zoom);
		$.getJSON('/_update_image', data_askFor, //asking for the new image
			function(data) {
                if(data.exit_code!=0){
                    show_error(2);
                    set_status(OSD_ready);
                    return;
                }
				console.log(data);
				viewer.tileSources.url = data.slide_url;
				viewer.addTiledImage({
                    tileSource: viewer.tileSources,
                    // autoResize: false,
                    // visibilityRatio: 0,
                    // minZoomImageRatio: 0,
                    // maxZoomPixelRatio: max_zoom,  // can be change to 10
                    success : function()
		            {
		                if(viewer.world.getItemCount()>2)
		                {
		                    viewer.world.removeItem(viewer.world.getItemAt(0));
		                    return;
		                }
		                viewer.world.removeItem(viewer.world.getItemAt(0));
                        viewer.viewport.zoomTo((data_askFor.var3-data_askFor.var1)/
                                                                        (DownRight_X-UpLeft_X),{},true);
                        // true = no animation
			            viewer.viewport.panTo({
                        x:((DownRight_X+UpLeft_X)/2-data_askFor.var1)/(data_askFor.var3-data_askFor.var1),
                        y:((DownRight_Y+UpLeft_Y)/2-data_askFor.var2)/(data_askFor.var3-data_askFor.var1),
                        },true);
			            // x and y should be relative center coor of the img.
                        UpLeft_X=data_askFor.var1;
                        UpLeft_Y=data_askFor.var2;
                        DownRight_X=data_askFor.var3;
                        DownRight_Y=data_askFor.var4;
                        X=data_askFor.var3-data_askFor.var1;
                        Y=data_askFor.var4-data_askFor.var2;
                        set_status(OSD_ready);
		            },
		            false : function()
		            {
		                show_error(2);
                        set_status(OSD_ready);
		            }
                });
				if (enableOverlay) {
                    viewer.addSimpleImage({
                        url: '/static/s.png',
                        replace: false,
                        opacity: 1,
                        success: function () {
                            viewer.viewport.zoomTo((data_askFor.var3 - data_askFor.var1) /
                                (DownRight_X - UpLeft_X), {}, true);
                            // true = no animation
                            viewer.viewport.panTo({
                                x: ((DownRight_X + UpLeft_X) / 2 - data_askFor.var1) / (data_askFor.var3 - data_askFor.var1),
                                y: ((DownRight_Y + UpLeft_Y) / 2 - data_askFor.var2) / (data_askFor.var3 - data_askFor.var1),
                            }, true);
                            // x and y should be relative center coor of the img.
                            UpLeft_X = data_askFor.var1;
                            UpLeft_Y = data_askFor.var2;
                            DownRight_X = data_askFor.var3;
                            DownRight_Y = data_askFor.var4;
                            X = data_askFor.var3 - data_askFor.var1;
                            Y = data_askFor.var4 - data_askFor.var2;
                        },
                    });
                }
			}
		);
        update_mag();
	};

    var update_bounds = function() {

        // Clear region selection
        if (reg_id != 0) {
            document.getElementById("reg_selected").id = "regid_" + String(reg_id);
            reg_id = 0;
        }

        var bounds = viewer.viewport.getBounds();

        UpLeft_X=UpLeft_X+bounds.x*X;
        UpLeft_Y=UpLeft_Y+bounds.y*X;
        DownRight_X =UpLeft_X+bounds.width*X;
        DownRight_Y =UpLeft_Y+bounds.height*X;
    };

    var update_scale_bar = function () {
        //update_scale_bar_status = 1;
        //while(update_scale_bar_status)
        {
            var zoom = viewer.viewport.getZoom(true);
            var imageZoom = viewer.viewport.viewportToImageZoom(zoom);
            var bar_length = X / zoom / 3 * um_per_px;
            var unit_length;
            var scale_bar_text = " ";
            if( bar_length <1) {
                unit_length = bar_length;
                scale_bar_text =  " " + unit_length + " um";
            }
            else if( bar_length <=5) {
                unit_length = Math.floor(bar_length);
                bar_length = unit_length;
                scale_bar_text =  " " + unit_length + " um";
            }
            else if( bar_length <=20) {
                unit_length = Math.floor(bar_length/5)*5;
                bar_length = unit_length;
                scale_bar_text =  " " + unit_length + " um";
            }
            else if( bar_length <100) {
                unit_length = Math.floor(bar_length/10)*10;
                bar_length = unit_length;
                scale_bar_text =  " " + unit_length + " um";
            }
            else if(bar_length <1000 ){
                unit_length = Math.floor(bar_length / 100);
                bar_length = unit_length * 100;
                scale_bar_text = " " + bar_length + " um";
            }
            else if( bar_length >1000 ) {
                unit_length = Math.floor(bar_length/1000);
                bar_length = unit_length * 1000;
                scale_bar_text =  " " + unit_length + " mm";
            }
            $("#scale_bar").text(scale_bar_text);
            document.getElementById("scale_bar").style.width = (bar_length *zoom
                    * document.getElementById("openseadragon1").clientWidth
                    / X / um_per_px -1)+"px"
            setTimeout(update_scale_bar,300)
        }
    };

    var update_zoom = function() { //do if pin changed
        var zoom = viewer.viewport.getZoom(true);
        var imageZoom = viewer.viewport.viewportToImageZoom(zoom);
        //update_scale_bar();
        //update_scale_bar_status =0 ;
        /*
        imageZoom>1 = zoom in more than image resolution
        zoom<1 = viewer larger than image
        (therefore) (zoom<1 && X<MAX_X) = only refresh for the 1st time that viewer is larger than image.
        X is of latest image
        MAX_X is of WSI
         */
		if(imageZoom>1||(zoom<1 && X<MAX_X)){
		    // Refresh image
            update_bounds();
		    update_image();
		}
        else {update_pin();}
    };

    var update_pin = function() {//do if out of bounds
		var bounds = viewer.viewport.getBounds();
		if((bounds.x<0&&UpLeft_X>0)||
           (bounds.y<0&&UpLeft_Y>0)||
           ((bounds.x+bounds.width) >1&&DownRight_X<MAX_X)||
           ((bounds.y+bounds.height)>(Y/X) &&DownRight_Y<MAX_Y))
        {
            {#console.log(bounds);#}
            update_bounds();
            update_image();
		}
    };

    var check_max_zoom_in = function(){
        var zoom = viewer.viewport.getZoom(true);
        var imageZoom = viewer.viewport.viewportToImageZoom(zoom);
        if(imageZoom > viewer.viewport.viewportToImageZoom(Max_zoom))
        {
            viewer.viewport.zoomTo(Max_zoom, PT_location, false);
        }
    };
    
    var add_overlay = function(x,y) {
        viewer.addOverlay({
            element: 'right-arrow-overlay',
            placement: 'RIGHT',
            checkResize: false,
            location: new OpenSeadragon.Point(x,y), 
        });
    };

    // Run the func after user interact with OSD
    viewer.addHandler('open', function(){

		update_image(); // get first image

        var tracker_location = new OpenSeadragon.MouseTracker({ //set mouse tracker
                element: viewer.container,
                moveHandler: Update_pointer_location,
                scrollHandler: Update_pointer_location,
            });

        var tracker = new OpenSeadragon.MouseTracker({ //set mouse tracker
                element: viewer.container,
                moveHandler: recording_point,
            });
        tracker.setTracking(false);

		viewer.addHandler('animation-finish', update_zoom);
        viewer.addHandler('animation-start', check_max_zoom_in);
		viewer.addHandler('animation', check_max_zoom_in);

		update_scale_bar();
		//viewer.addHandler('animation-start', update_scale_bar());

        viewer.addHandler('canvas-nonprimary-press',  function (e) {
            if(e.button==2 && status==0){
                recording_point(e);tracker.setTracking(true);}
         });
        viewer.addHandler('canvas-nonprimary-release',  function (e) {
            if(e.button==2 && status==0){
                tracker.setTracking(false);

                set_status(OSD_posting);
                $.post("/_record",data_draw).done(function(data){
                    console.log(data);
                    data_draw={};
                    point_number=0;
                    // Disable the image updating after the click or the drag to annotate.
		            var pt_false ='('
		            if(data.pt_false_x.length!=0){
		                for(var i=0 ; i<data.pt_false_x.length ; i++)
		                    {
		                        x = (data.pt_false_x[i] - UpLeft_X)/X;
		                        y = (data.pt_false_y[i] - UpLeft_Y)/Y;
		                        pt_false = pt_false + '(' + parseInt(data.pt_false_x[i]) + ',' +parseInt(data.pt_false_y[i]) + ')' + ',';
		                    }
		            }
		            pt_false = pt_false + ')';
		            set_status(OSD_waiting);
		            update_bounds();
		            update_image(pt_false);
		            //console.log(data.pt_false_x.length);
                    }).fail(function(){
                        set_status(OSD_ready);
                        show_error(1);
                        set_status(OSD_ready);
                        data_draw={};
                        point_number=0;
                });
                }
        });  
    });

    var toggle_boundary = function() {
        console.log("toggle sub-region boundary");
        if(OSD_status != 0) {show_error(3);return;}
        set_status(OSD_posting);
        $.getJSON(
            '/_tog_boun',
            {cmd: 1,},
            function(data) {
                console.log(data.status);
                $("#tog_result").text("Boundary (on/off): " + data.result);
                set_status(OSD_waiting);
                update_bounds();
                update_image();
            });
    };

    document.onkeydown=function(e){  //listen to the keboard;
        var key=String.fromCharCode(window.event ? e.keyCode :e.which);
        console.log(key);
        if(document.getElementById(""+key))
        {
            document.getElementById(""+key).checked=true;
            document.getElementById(""+key).onchange();
            // Disable the image updating after the click or the drag to annotate.
            //update_bounds();
            //update_image();
        }

        if(key == 'R' || key == 'Z' || key == 'X' || key == 'C' || key == 'T'){
            console.log('Refreshing image with a key');
            if(key == 'T'){
                toggle_boundary();
            }
            else {
                update_bounds();
                update_image();
            }
        }

    };

    </script>

<script>
    // Undo function
    $(function() {
        $('a#undo').bind('click', function() {
            if(OSD_status != 0) {show_error(3);return;}
            set_status(OSD_posting);
            $.getJSON(
                '/_undo',
                {cmd: 1,},
                //$('input[name="cmd"]').val()
                function(data) {
                        console.log(data.status);
                        update_bounds();
                update_image();});
            return false;
        });
    });

    /*
    // Change annotator id
    $(function() {
        $('a#anno_id').bind('click', function() {
            console.log("sending annotator id");
            $.getJSON(
                '/_annotator_id',
                {id: $('input[name="anno_id"]').val(),},
                function(data) {
                    console.log(data.status);
                    $("#annotator_result").text("Current annotator: " + data.result);
                });
            return false;
        });
    });
    */

    // Change slide id
    $(function() {
        $('a#slide_id').bind('click', function() {
            if(OSD_status != 0) {show_error(3);return;}
            set_status(OSD_posting);
            console.log("Sending slide id and wait for return value");
            $.getJSON(
                '/_change_slide_id',
                {id: $('input[name="slide_id"]').val(),},
                function(data) {
                    if(data.status == 'slide id update successful'){
                        // Print the returning information
                        console.log(data.status);
                        $("#change_result_flash").empty();

                        // Fetch data from '#slide_result' field and send as JSON
                        $("#slide_result").text("Current slide: " + data.result);
                        document.getElementById("slide_id_input_box").setAttribute("value", data.result);

                        console.log("Now reloading the slide");
                        // Reload image info in the front-end
                        _update_image_info();

                        // Refresh the image
                        {#update_bounds();#}
                        UpLeft_X=0;
                        UpLeft_Y=0;
                        DownRight_X =UpLeft_X + X;
                        DownRight_Y =UpLeft_Y + X;

                        set_status(OSD_waiting);
                        update_image();
                        slide_info_update();
                    }
                    else{
                        $("#change_result_flash").empty();
                        $("#change_result_flash").append(data.status)
                    }
                }
            );
            return false;
        });
    });

    // Set top-left coordinate
    $(function() {
        $('a#update_img_man').bind('click', function() {
            console.log("Using manual option to update the image...");
            var bounds = viewer.viewport.getBounds();

            UpLeft_X = parseInt($('input[name="tl_x1"]').val(), 10);
            UpLeft_Y = parseInt($('input[name="tl_y1"]').val(), 10);

            manLoc_w = parseInt($('input[name="tl_x2"]').val(), 10);

            var wh_ratio = bounds.height / bounds.width;

            DownRight_X = UpLeft_X + manLoc_w;
            DownRight_Y = UpLeft_Y + (manLoc_w * wh_ratio);

            update_image();

            return false;
        });
    });

    // Update to low magnification
    $(function() {
        $('a#mag_l').bind('click', function() {
            console.log("Update image to LOW magnification view...");
            var bounds = viewer.viewport.getBounds();

            // Calculate for the center of the image
            var center_x = (UpLeft_X + DownRight_X) / 2;
            var center_y = (UpLeft_Y + DownRight_Y) / 2;

            var wh_ratio = bounds.height / bounds.width;    // width-to-height ratio = wh_ratio, based on the viewer sz.

            // Calculate the viewing width needed to be displayed
            var px_disp_width = low_mag_dim / micron_per_pixel;
            var px_disp_height = px_disp_width * wh_ratio;

            var new_tl_x = center_x - (px_disp_width/2);
            var new_tl_y = center_y - (px_disp_height/2);

            // Transfer back to original variable name
            UpLeft_X = new_tl_x;
            UpLeft_Y = new_tl_y;

            DownRight_X = UpLeft_X + px_disp_width;
            DownRight_Y = UpLeft_Y + px_disp_height;

            update_image();     // Run normal update_image routine.

            return false;
        });
    });

    // Update to high magnification
    $(function() {
        $('a#mag_h').bind('click', function() {
            console.log("Update image to HIGH magnification view...");
            var bounds = viewer.viewport.getBounds();

            // Calculate for the center of the image
            var center_x = (UpLeft_X + DownRight_X) / 2;
            var center_y = (UpLeft_Y + DownRight_Y) / 2;

            var wh_ratio = bounds.height / bounds.width;    // width-to-height ratio = wh_ratio, based on the viewer sz.

            // Calculate the viewing width needed to be displayed
            var px_disp_width = high_mag_dim / micron_per_pixel;
            var px_disp_height = px_disp_width * wh_ratio;

            var new_tl_x = center_x - (px_disp_width/2);
            var new_tl_y = center_y - (px_disp_height/2);

            // Transfer back to original variable name
            UpLeft_X = new_tl_x;
            UpLeft_Y = new_tl_y;

            DownRight_X = UpLeft_X + px_disp_width;
            DownRight_Y = UpLeft_Y + px_disp_height;

            update_image();     // Run normal update_image routine.

            return false;
        });
    });

    // Add current region (sub-window) to the TBA list.
    $(function() {
        $('a#add_sw').bind('click', function() {
            console.log("Add current region (sub-window) to the TBA list.");
            // Calculate for the center of the image
            var center_x = parseInt((UpLeft_X + DownRight_X) / 2);
            var center_y = parseInt((UpLeft_Y + DownRight_Y) / 2);

            // Check viewing area width
            var viewing_width = DownRight_X - UpLeft_X;
            var low_mag_width = (low_mag_dim/um_per_px) + ((low_mag_dim/um_per_px)*(buffer*2));

            if (viewing_width == low_mag_width) {
                // Send the coordinate to the system
                $.getJSON(
                    '/_add_sw',
                    {x: center_x, y: center_y},
                    function(data) {
                        var proc_status = parseInt(data.num_status);
                        if(proc_status == 1){
                            // Print the returning information
                            console.log(data.status);

                            update_tb_list();
                        }
                        else{
                            console.log("Adding sub-window has failed.")
                        }
                    }
                );
            }
            else {
                document.getElementById("tb_warn").innerHTML = "Cannot add: Click 'Magnification: Low' first.";
            }


            return false;
        });
    });

    // Remove current region (sub-window) from the TBA list.
    $(function() {
        $('a#rm_sw').bind('click', function() {
            console.log("Remove current region (sub-window) from the TBA list.");
            if (reg_id != 0) {
                // Send request to remove current "reg_id"
                $.getJSON(
                    '/_rm_sw',
                    {sw_id: reg_id},
                    function(data) {
                        var proc_status = parseInt(data.num_status);
                        if(proc_status == 1){
                            // Print the returning information
                            console.log(data.status);

                            update_tb_list();
                        }
                        else{
                            console.log("Removing sub-window has failed.")
                        }
                    }
                );
                reg_id = 0;
            }
            else {
                document.getElementById("tb_warn").innerHTML = "Cannot remove: Select the 'Region X' first.";
            }

            return false;
        });
    });

    // Toggle sub-region boundary
    $(function() {
        $('a#tog_boun').bind('click', function() {
            toggle_boundary();
            return false;
        });
    });

    </script>

<script>
		$(document).ready(function(){
  			$("#clinical_meta_data").click(function(){
    		$("#patient_info").slideToggle("slow");
  			});
		});
		$(document).ready(function(){
  			$("#bio_meta_data").click(function(){
    		$("#bio_info").slideToggle("slow");
  			});
		});
		var demographic_update=function() {
            var data = JSON.stringify('demographic');
            $.ajax({
                type: 'POST',
                url: '/get_patient_meta/',
                async: true,
                data: data,
                contentType: 'application/json',
            })
                .done(function (data) {
                    result = JSON.parse(data);
                    $('#demographic_info').empty();
                    $.each(result, function (key, value) {
                        //alert(key,value);
                        //$('#successAlert').text(key+":"+value+'<br>').show();

                        $('#demographic_info').append("<div id='property'><b>" + key + "</b>:  " + value + '</div>');
                        $('#property').attr('id', key)
                    })
                    $('#ethnicity').mouseenter(function () {
                        $('#ethnicity').append('<div class="ethnicity_inter" style="font-size:13px;color:red">(An individual\'s self-described social and cultural grouping, specifically whether an individual describes themselves as Hispanic or Latino. The provided values are based on the categories defined by the U.S. Office of Management and Business and used by the U.S. Census Bureau.)</div>')
                    })
                    $('#ethnicity').mouseleave(function () {
                        $('.ethnicity_inter').css("display", "none");
                    })
                    $('#gender').mouseenter(function () {
                        $('#gender').append('<div class="gender_inter" style="font-size:13px;color:red">(Male or Female.)</div>')
                    })
                    $('#gender').mouseleave(function () {
                        $('.gender_inter').css("display", "none");
                    })
                    $('#days_to_birth').mouseenter(function () {
                        $('#days_to_birth').append('<div class="days_to_birth_inter" style="font-size:13px;color:red">(Number of days between the date used for index and the date from a person\'s date of birth represented as a calculated negative number of days.)</div>')
                    })
                    $('#days_to_birth').mouseleave(function () {
                        $('.days_to_birth_inter').css("display", "none");
                    })
                    $('#days_to_death').mouseenter(function () {
                        $('#days_to_death').append('<div class="days_to_death_inter" style="font-size:13px;color:red">(Number of days between the date used for index and the date from a person\'s date of death represented as a calculated number of days.)</div>')
                    })
                    $('#days_to_death').mouseleave(function () {
                        $('.days_to_death_inter').css("display", "none");
                    })
                    $('#vital_status').mouseenter(function () {
                        $('#vital_status').append('<div class="vital_status_inter" style="font-size:13px;color:red">(The survival state of the person registered on the protocol.)</div>')
                    })
                    $('#vital_status').mouseleave(function () {
                        $('.vital_status_inter').css("display", "none");
                    })
                });

            event.preventDefault();
        };
		$(document).ready(function(){
  			$("#demographic").click(function(){
    		$("#demographic_info").slideToggle("slow");
            demographic_update();
  			});
		});

		var diagnosis_update=function(){
		    var data=JSON.stringify('diagnosis');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#diagnosis_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#diagnosis_info').append("<div id='property'><b>"+key+"</b>:  "+value+'</div>');
						$('#property').attr('id',key)
					})
                    $('#tumor_grade').mouseenter(function(){
                        $('#tumor_grade').append('<div class="tumor_grade_inter" style="font-size:13px;color:red">(Enumeration:G1,G2,G3,G4,GX,GB,High Grade,Low Grade,Unknown)</div>')
                    })
                    $('#tumor_grade').mouseleave(function(){
                        $('.tumor_grade_inter').css("display","none");
                    })
				});

				event.preventDefault();

  			};
		$(document).ready(function(){
  			$("#diagnosis").click(function(){
    		$("#diagnosis_info").slideToggle("slow");
    		diagnosis_update();
  			});
		});

		var exposure_update=function(){
		    var data=JSON.stringify('exposure');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#exposure_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#exposure_info').append("<div><b>"+key+"</b>"+":  "+value+'</div>');
					})
				});

				event.preventDefault();
        };
		$(document).ready(function() {
            $("#exposure").click(function () {
                $("#exposure_info").slideToggle("slow");
                exposure_update();
            });
        });


  		var family_history_update=function(){
  		    var data=JSON.stringify('family_history');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
				    if(data=='{}'){
					    $('#family_history_info').css("display:block");
                    }
                    else{
                        result=JSON.parse(data);
					    $('#family_history_info').empty();
                        $.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();
						$('#family_history_info').append("<div><b>"+key+"</b>"+":  "+value+'</div>');
					})
                    }
				});

				event.preventDefault();
        }
		$(document).ready(function(){
  			$("#family_history").click(function(){
    		$("#family_history_info").slideToggle("slow");
    		family_history_update();
  			});
		});

  		var molecular_test_update=function(){
  		    var data=JSON.stringify('molecular_test');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
				    if(data=='{}'){
					    $('#molecular_test_info').css("display:block");
                    }
                    else {
                        result=JSON.parse(data);
					$('#molecular_test_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#molecular_test_info').append("<div><b>"+key+"</b>"+":  "+value+'</div>');
					})
                    }
				});

				event.preventDefault();
        }
		$(document).ready(function(){
  			$("#molecular_test").click(function(){
    		$("#molecular_test_info").slideToggle("slow");
    		molecular_test_update();
  			});
		});

  		var treatment_update=function(){
  		    var data=JSON.stringify('treatment');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
				    if(data=='{}'){
					    $('#treatment_info').css("display:block");
                    }
                    else{
                        result=JSON.parse(data);
					$('#treatment_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#treatment_info').append("<div><b>"+key+"</b>"+":  "+value+'</div>');
					})
                    }
				});

				event.preventDefault();
        }
		$(document).ready(function(){
  			$("#treatment").click(function(){
    		$("#treatment_info").slideToggle("slow");
    		treatment_update();
  			});
		});

  		var follow_up_update=function(){
  		    var data=JSON.stringify('follow_up');
    		$.ajax({
					type:'POST',
					url:'/get_patient_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
				    if(data=='{}'){
					    $('#follow_up_info').css("display:block");
                    }
                    else{
                        result=JSON.parse(data);
					$('#follow_up_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#follow_up_info').append("<div><b>"+key+"</b>"+":  "+value+'</div>');
					})
                    }
				});

				event.preventDefault();
        }
		$(document).ready(function(){
  			$("#follow_up").click(function(){
    		$("#follow_up_info").slideToggle("slow");
    		follow_up_update();
  			});
		});

  		var slide_update=function(){
  		    var data=JSON.stringify('slide');
    		$.ajax({
					type:'POST',
					url:'/get_bio_meta/',
					async:true,
                    data:data,
					contentType:'application/json'
				})
				.done(function(data){
					result=JSON.parse(data);
					$('#slide_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#slide_info').append("<div><b>"+key+"</b>"+":  "+value+'</div>');
					})
				});

				event.preventDefault();
        }
		$(document).ready(function(){
  			$("#slide").click(function(){
    		$("#slide_info").slideToggle("slow");
    		slide_update();
  			});
		});

  		var portion_update=function(){
  		    var data=JSON.stringify('portion');
    		$.ajax({
					type:'POST',
					url:'/get_bio_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#portion_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#portion_info').append("<div><b>"+key+"</b>"+":  "+value+'</div>');
					})
				});

				event.preventDefault();
        }
		$(document).ready(function(){
  			$("#portion").click(function(){
    		$("#portion_info").slideToggle("slow");
    		portion_update();
  			});
		});

  		var sample_update=function(){
  		    var data=JSON.stringify('sample');
    		$.ajax({
					type:'POST',
					url:'/get_bio_meta/',
					async:true,
                    data:data,
					contentType:'application/json',

				})
				.done(function(data){
					result=JSON.parse(data);
					$('#sample_info').empty();
					$.each(result,function(key,value){
						//alert(key,value);
						//$('#successAlert').text(key+":"+value+'<br>').show();

						$('#sample_info').append("<div><b>"+key+"</b>"+":  "+value+'</div>');
					})
				});

				event.preventDefault();
        }
		$(document).ready(function(){
  			$("#sample").click(function(){
    		$("#sample_info").slideToggle("slow");
    		sample_update();
  			});
		});

  		var slide_info_update=function(){
            demographic_update();
            diagnosis_update();
            exposure_update();
            family_history_update();
            follow_up_update();
            molecular_test_update();
            treatment_update();
            slide_update();
            sample_update();
            portion_update();
        }

		$(function(){
            $("#sr_update").click(function(){
                update_mag();
                return false;
            });
        });

        $(function(){
            $("#ss_update").click(function(){
                update_mag();
                return false;
            });
        });

        $(function(){
            $("#ds_update").click(function(){
                update_mag();
                return false;
            })
        })

        $(function(){
            $("#virtual-mag-usr-input").click(function(){
                update_mag(function(data){
                    var targzoom = parseFloat(document.getElementById("input-vmag").value);
                    var currzoom = data.abs;
                    viewer.viewport.zoomTo(targzoom / currzoom);
                });
            })
        })
	</script>￼
</body>

</html>

{% endblock %}